      IMPLICIT REAL*8 (A-H,O-Z)
         OPEN(6,FILE='global.chk')
c         OPEN(6,FILE='test-02.chk')
       phi=0.0d0
       theta=115.44
       r=3.814
         call H2OKr_3DPES(phi,theta,r,v,1)
             write(*,999)phi,theta,r,v
c output v=-169.41682
 999  format(1x,3F8.2,F25.5)
      end
c******************************************************************************
      SUBROUTINE H2OKr_3DPES(XPHI,TH,RR,V,iv)
c******************************************************************************
c Subroutine to generate values of the 3D-MLR analyic vibrationally averaged
c   PESs for complexes formed between Ne and H2O, at given vibrational
c   excited states
c-------------------------------------------------------------------------
c  iv=1 for  00+ > refer to 000    
c  iv=2 for  02- > refer to 101   
c  iv=3 for  02+ > refer to 200  
c  iv=4 for  11+ > refer to 002    
c-----------------------------------------------------------------------------
c  RR  - distance between Kr and H2O centre of mass in [Angst]
c  TH  - Jacobi angular coordinate 'theta' in degrees 
c  PHI  - Jacobi angular coordinate 'phi' in degrees  
c** Output:   V [cm-1]  is the calculated interaction energy.
c-----------------------------------------------------------------------------

      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER MXDATA,MXPARM,NPMAX,MMAX,MXDE,MXRE,MXPHI,isH,isO
      PARAMETER (MXDATA=5000, MXPARM=600, NPMAX=20, MMAX=16)
      PARAMETER (isp=4, MXDE=16,MXRE=16,MXPHI=38)
c isp--the number of CN,CS
      PARAMETER (isH=1,isO=16)
      REAL*8  YPHI,YTH,YR,XPHI,TH,RR,PHI(MXPARM)
      REAL*8  DM(MMAX),DMP(MMAX),DMPP(MMAX),ylm,RTP(MXDATA)
      REAL*8  YC,Re,De,phiINF,RTPp,RTPq,yp,yq,ype,yPOW,SUM,
     2 DSUM,XP,VLR,XPW
c-----------------------------------------------------------------------
      INTEGER NPHI(0:NPMAX),I,J,K,L,M,IP,IS,NP,NQ,NLDE,
     1 NLRE,NCN,NCS,MCM,NS,NL,NPOW,NPS,NTP0,MMN,M6,iv
      REAL*8 DEDE(0:ISP+1,MXDE),RERE(0:ISP+1,MXRE),PHIPHI(0:ISP+1,MXPHI)
     1  ,XCN(ISP),XRCN2CN(ISP),XRCN22CN(ISP),XCS(ISP),XRCS1CN(ISP),
     2  XRCS30CN(ISP),XRCS32CN(ISP),XRCMCN(ISP),
     2  XRCM2CN(ISP),XRCM40CN(ISP),XRCM42CN(ISP),Xua2ba(ISP),PI,
     #  XRCM22CN(ISP),XRCM44CN(ISP)
      REAL*8  PV(MXPARM),PD(MXPARM),PS(MXPARM),RMSR,Vasy,
     1  RREF,AREF,AREFp,AREFq,Rep,CN,RCN2CN,RCN22CN,RCS1CN,RCS30CN,
     2 RCMCN,RCS32CN,RCM22CN,RCM40CN,RCM42CN,
     2 RCM2CN,RCM44CN,VLRe,dVLRedRe,XRE,C6Sum,C7Sum,C8Sum,bDAMP,
     3 T0,V


c-----------------------------------------------------------------------
c  input parameters which are the same for all isotopologues
      DATA IPAR/0/
      SAVE IPAR
c-----------------------------------------------------------------------------
      IF(IPAR.EQ.0) THEN
          call fct(40)
      IPAR= 1
      ENDIF

c  input parameters which are the same for all isotopologues
      DATA NLDE/6/
      DATA NLRE/6/
      DATA NP/3/
      DATA NQ/3/
      DATA NS/4/
      DATA NL/3/
      DATA RREF/1.6d0/
      NPOW=NL
      DATA (NPHI(I),I=0,3)/6,4,4,2/
      DATA bDAMP/-3.08d0/
      DATA NCN/6/
      DATA NCS/7/
      DATA MCM/8/
c-----------------------------------------------------------------------
c  input initial parameters which are changed with different isotope case
      DATA (XCN(I),I=1,ISP)/0.416460769D+06,0.417567557D+06,
     & 0.410565477D+06,0.430857271D+06/
      DATA (XRCN2CN(I),I=1,ISP)/0.107212980D+01,0.112508741D+01,
     & 0.117715694D+01,0.109804344D+01/
      DATA (XRCN22CN(I),I=1,ISP)/0.609421149,0.578110047,
     & 0.618658933,0.547048909/
      DATA (XRCS1CN(I),I=1,ISP)/-0.160879499D+01,-0.177935280D+01
     & ,-0.207031533D+01,-0.197049013D+01/
      DATA (XRCS30CN(I),I=1,ISP)/0.297747133,0.280194182,
     & 0.309329467,0.248342101/
      DATA (XRCS32CN(I),I=1,ISP)/-0.826008176,-0.850161834,
     & -0.954780716,-0.877320693/
      DATA (XRCMCN(I),I=1,ISP)/0.201411529D+03,0.205451785D+03
     & ,0.215532004D+03,0.201923017D+03/
      DATA (XRCM2CN(I),I=1,ISP)/-0.615424115D+02,-0.648038852D+02,
     & -0.673948531D+02,-0.619462680D+02/
      DATA (XRCM22CN(I),I=1,ISP)/-0.340968491D+02,-0.311326869D+02,
     & -0.328814787D+02,-0.290119277D+02/
      DATA (XRCM40CN(I),I=1,ISP)/0.0,0.0,0.0,0.0/
      DATA (XRCM42CN(I),I=1,ISP)/0.0,0.0,0.0,0.0/
      DATA (XRCM44CN(I),I=1,ISP)/0.0,0.0,0.0,0.0/

c     isC=12, isF=16, isH=32, (v1,v3)=(0,0)   opt-re-fitted
      DATA (DEDE(1,I),I=1,MXDE)/
     &     4.896700000D+02,
     &    -4.760000000D+00,
     &     8.880000000D+00,
     &     5.209000000D+01,
     &     0.000000000D+00,
     &    -6.750000000D+00,
     &    -2.380000000D+00,
     &     3.600000000D+00,
     &     7.140000000D+00,
     &     4.700000000D-01,
     &    -3.600000000D-01,
     &    -5.200000000D-01,
     &     6.700000000D-01,
     &    -1.030000000D+00,
     &     9.400000000D-01,
     &     3.200000000D-01/



      DATA (RERE(1,I),I=1,MXRE)/
     &    1.323750000D+01,
     &   -2.236000000D-01,
     &   -5.000000000D-04,
     &   -7.570000000D-02,
     &    5.800000000D-02,
     &   -9.820000000D-02,
     &   -2.300000000D-03,
     &    3.600000000D-03,
     &   -4.000000000D-04,
     &   -9.000000000D-04,
     &    9.000000000D-04,
     &   -1.000000000D-03,
     &   -3.220000000D-03,
     &    4.600000000D-03,
     &   -4.100000000D-03,
     &    1.200000000D-03/
    

      DATA (PHIPHI(1,I),I=1,MXPHI)/

     & -3.0060D+00, -3.1800D-01, 1.2600D-01,
     &  3.4100D-01, 8.7000D-02, -1.7200D-01,
     & -8.0000D-03, 2.6000D-02, 3.2000D-02,
     &  3.0000D-03, -3.0000D-03, -2.0000D-03,
     & -4.0000D-03, 5.0000D-03, -5.0000D-03,
     &  0.0000D+00, 3.8800D+00, 1.3000D-01,
     &  0.0000D+00, 4.0000D-02, -4.0000D-02,
     &  4.0000D-02, 0.0000D+00, 0.0000D+00,
     &  0.0000D+00, 1.7000D+00, 1.9000D-01,
     &  1.3400D-01, 0.0000D+00, -5.0000D-02,
     &  5.0000D-02, -1.0000D-02, 0.0000D+00,
     &  0.0000D+00, 3.1800D+00, 0.0000D+00,
     &  1.0000D-01, 0.0000D+00/

      
c     isO=16, isH=1, (v1,v3)=(2,0)   opt-re-fitted
      DATA (DEDE(2,I),I=1,MXDE)/
     &  4.95330D+02, -2.14000D+00, 7.82000D+00,
     &  5.25500D+01, 1.70000D-01, -5.47000D+00,
     & -2.75000D+00, 3.91000D+00, 7.18000D+00,
     &  4.60000D-01, -2.90000D-01, -5.70000D-01,
     &  7.10000D-01, -1.13000D+00, 1.13000D+00,
     &  2.90000D-01/



      DATA (RERE(2,I),I=1,MXRE)/
     &  1.324620D+01, -2.490000D-01, 4.800000D-03,
     & -6.530000D-02, 5.520000D-02, -1.035000D-01,
     &  6.000000D-04, 8.000000D-04, 1.200000D-03,
     & -1.800000D-03, 1.500000D-03, -1.000000D-03,
     & -2.430000D-03, 3.800000D-03, -3.700000D-03,
     &  1.000000D-03/




      DATA (PHIPHI(2,I),I=1,MXPHI)/
     & -3.0420D+00, -3.2400D-01, 1.3600D-01,
     &  3.3100D-01, 8.1000D-02, -1.7600D-01,
     & -8.0000D-03, 2.4000D-02, 3.7000D-02,
     &  1.0000D-03, -3.0000D-03, -3.0000D-03,
     & -1.0000D-03, 1.0000D-03, 0.0000D+00,
     &  0.0000D+00, 3.8900D+00, 1.3000D-01,
     &  0.0000D+00, 0.0000D+00, -5.0000D-02,
     &  0.0000D+00, 0.0000D+00, 0.0000D+00,
     &  1.0000D-02, 1.8000D+00, 1.9000D-01,
     &  1.2000D-01, 0.0000D+00, -6.0000D-02,
     &  0.0000D+00, 0.0000D+00, 0.0000D+00,
     &  0.0000D+00, 3.3200D+00, 0.0000D+00,
     &  1.0000D-01, 9.0000D-02/




c     isO=16, isH=1, (v1,v3)=(1,1)   opt-re-fitted
      DATA (DEDE(3,I),I=1,MXDE)/
     &    5.0485D+02, -3.1600D+00, 7.2600D+00,
     &    5.5230D+01, 9.5000D-01, -6.8100D+00,
     &   -3.2700D+00, 4.7200D+00, 7.3500D+00,
     &    7.8000D-01, -6.4000D-01, -7.0000D-01,
     &    7.2000D-01, -1.1500D+00, 1.2500D+00,
     &    3.8000D-01/



      DATA (RERE(3,I),I=1,MXRE)/
     &   1.32511D+01, -2.71800D-01, 1.82000D-02,
     &  -6.54000D-02, 5.42000D-02, -1.06300D-01,
     &  -2.30000D-03, 3.50000D-03, 0.00000D+00,
     &  -4.00000D-04, 6.00000D-04, 4.00000D-04,
     &  -3.80000D-03, 5.10000D-03, -5.20000D-03,
     &   1.10000D-03/


      DATA (PHIPHI(3,I),I=1,MXPHI)/
     &  -3.0590D+00, -3.5100D-01, 1.4700D-01,
     &   3.4400D-01, 8.1000D-02, -1.8100D-01,
     &  -1.3000D-02, 2.8000D-02, 2.5000D-02,
     &   3.0000D-03, -6.0000D-03, 2.0000D-03,
     &  -4.0000D-03, 5.0000D-03, -4.0000D-03,
     &   2.0000D-03, 3.8800D+00, 1.5000D-01,
     &   0.0000D+00, 5.0000D-02, -7.0000D-02,
     &   0.0000D+00, 0.0000D+00, 0.0000D+00,
     &   0.0000D+00, 1.7000D+00, 2.2000D-01,
     &   2.5000D-01, 0.0000D+00, -1.0000D-01,
     &   0.0000D+00, 0.0000D+00, 0.0000D+00,
     &   2.0000D-02, 3.2400D+00, 0.0000D+00,
     &   3.0000D-01, 0.0000D+00/


c     isO=16, isH=1, (v1,v3)=(0,2)   opt-re-fitted
      DATA (DEDE(4,I),I=1,MXDE)/
     &   5.05670D+02, -4.32000D+00, 8.33000D+00,
     &   5.52700D+01, 7.20000D-01, -7.11000D+00,
     &  -3.33000D+00, 5.04000D+00, 7.38000D+00,
     &   8.90000D-01, -7.90000D-01, -6.70000D-01,
     &   6.40000D-01, -1.04000D+00, 1.20000D+00,
     &   3.70000D-01/
    

      DATA (RERE(4,I),I=1,MXRE)/
     &    1.32459D+01, -2.67900D-01, 1.97000D-02,
     &   -7.03000D-02, 5.03000D-02, -1.02300D-01,
     &   -8.00000D-04, 1.70000D-03, 0.00000D+00,
     &   -1.10000D-03, 1.20000D-03, 0.00000D+00,
     &   -3.20000D-03, 4.40000D-03, -4.60000D-03,
     &    1.10000D-03/


      DATA (PHIPHI(4,I),I=1,MXPHI)/
     &   -3.0240D+00, -3.6000D-01, 1.4900D-01,
     &    3.2500D-01, 7.7000D-02, -1.7200D-01,
     &   -1.2000D-02, 2.9000D-02, 3.8000D-02,
     &    4.0000D-03, -5.0000D-03, 1.0000D-03,
     &   -3.0000D-03, 4.0000D-03, -4.0000D-03,
     &    2.0000D-03, 3.9100D+00, 1.4000D-01,
     &    0.0000D+00, 0.0000D+00, -5.0000D-02,
     &    4.0000D-02, 0.0000D+00, 0.0000D+00,
     &    4.0000D-02, 1.8000D+00, 2.8000D-01,
     &    1.9000D-01, -5.0000D-02, -7.0000D-02,
     &    5.0000D-02, 0.0000D+00, 0.0000D+00,
     &    5.0000D-02, 3.3400D+00, 1.0000D-01,
     &    2.0000D-01, 0.0000D+00/

c-----------------------------------------------------------------------

      IF((isH.EQ.1).and.(isO.EQ.16).and.(iv.EQ.1)) isv= 1
      IF((isH.EQ.1).and.(isO.EQ.16).and.(iv.EQ.2))
     & isv= 2
      IF((isH.EQ.1).and.(isO.EQ.16).and.(iv.EQ.3))
     & isv= 3
      IF((isH.EQ.1).and.(isO.EQ.16).and.(iv.EQ.4))
     & isv= 4

      PI=DACOS(-1.0D0)
c... input initial parameters which are changed with different isotope case 
      CN=XCN(isv)
      RCN2CN=XRCN2CN(isv)
      RCN22CN=XRCN22CN(isv)
      RCS1CN=XRCS1CN(isv)
      RCS30CN=XRCS30CN(isv)
      RCS32CN=XRCS32CN(isv)
      RCMCN=XRCMCN(isv)
      RCM2CN=XRCM2CN(isv)
      RCM22CN=XRCM22CN(isv)
      RCM40CN=XRCM40CN(isv)
      RCM42CN=XRCM42CN(isv)
      RCM44CN=XRCM44CN(isv)
      IS=0
      IPDE=0
      DO L=0,NLDE
c... first prepare well depth expansion parameters
          if (L.GT.6) then
              M6=6
          else
             M6=L
          endif
           DO M=0,M6,2
             IS=IS+1
             IPDE=IPDE+1
             PV(IS)=DEDE(isv,IPDE)
c         write(13,123)DEDE,PV(IS)
123       format(2x,2f25.8)
           ENDDO
      ENDDO
      IPRE=0
      DO L=0,NLRE
c... next prepare potential minimum position expansion parameters
          if (L.GT.6) then
              M6=6
          else
             M6=L
          endif
            DO M=0,M6,2
              IS=IS+1
              IPRE=IPRE+1
              PV(IS)=RERE(isv,IPRE)
            ENDDO
      ENDDO
        IPPHI=0
        NPS=0
        K=0
      DO J=0,NPOW
c... then, prepare exponent coefficient \beta_i expansion parameters
         DO L=0,NPHI(J)
            if (L.GT.6) then
              M6=6
            else
             M6=L
            endif
              DO M=0,M6,2
                IS=IS+1
                IPPHI=IPPHI+1
                PV(IS)=PHIPHI(isv,IPPHI)
c         write(14,124)IPPHI,PHIPHI,PV(IS)
124       format(2x,3f25.8)
              ENDDO
           ENDDO
       ENDDO
c** Finally ... (if desired) read shift for definition of energy zero
      IS=IS+1
      PV(IS)=0.0D0
cccc----------------------------------------------------------------ccccc
           PI=DACOS(-1.0D0)
           YR=RR
           YPHI=XPHI*PI/180.D0
           YTH=TH*PI/180.D0

c=======================================================================
c  For the case of an  MLR_{p}  potential ...
c-----------------------------------------------------------------------
c caculate the derivative of the parameters of De not including
c the coefficient before, only the Legendre expansion.
        IP=0
        De=0.0d0
        DO L=0,NLDE        ! change with NDE  
          if (L.GT.6) then
              M6=6
          else
             M6=L
          endif
           DO M=0,M6,2
             IP=IP+1
             PD(IP)=ylm(L,M,YTH,YPHI)
             De=De+PV(IP)*PD(IP)
c            WRITE(60,*)De,PV(IP),PD(IP)
            ENDDO
        ENDDO
c caculate the derivative of the parameters of Re not including
c the coefficient before, only the Associated Legendre expansion.

       Re=0.0d0
        DO L=0,NLRE        ! change with  NRE 
          if (L.GT.6) then
              M6=6
          else
             M6=L
          endif
           DO M=0,M6,2
             IP=IP+1
             PD(IP)=ylm(L,M,YTH,YPHI)
             Re=Re+PV(IP)*PD(IP)
            ENDDO
        ENDDO

       AREF= RREF*Re
       IF(RREF.LE.0.d0) AREF= Re
       AREFp= AREF**NP
       AREFq= AREF**NQ
       Rep= Re**NP
       C6Sum=0.0d0
       C6Sum=1.+ylm(2,0,YTH,YPHI)*RCN2CN+ylm(2,2,YTH,YPHI)*RCN22CN
       IF(bDAMP.GT.0.d0) CALL DAMPIG(Re,bDAMP,MMAX,DM,DMP,DMPP)
         T0= CN*C6Sum/Re**NCN
         IF(bDAMP.GT.0.d0) T0= T0*DM(NCN)
         VLRe= T0
c         dVLRedRe= -NCN*T0/Re
c         IF(bDAMP.GT.0.d0)
c     &    dVLRedRe= dVLRedRe + T0*DMP(NCN)/DM(NCN)
       C7Sum=0.0d0
       C7Sum=ylm(1,0,YTH,YPHI)*RCS1CN+ylm(3,0,YTH,YPHI)*RCS30CN+
     &    ylm(3,2,YTH,YPHI)*RCS32CN
       C8Sum=0.0d0
       C8Sum=RCMCN+ylm(2,0,YTH,YPHI)*RCM2CN+ylm(2,2,YTH,YPHI)*RCM22CN+
     & ylm(4,0,YTH,YPHI)*RCM40CN+ylm(4,2,YTH,YPHI)*RCM42CN
     & +ylm(4,4,YTH,YPHI)*RCM44CN


       IF(MCM.GT.NCN) THEN
        MMN= MCM - NCN
       IF(NP.LE.MMN) MMN= 0
       IF(MMN.GT.0) THEN
C  with and without damping function 
       IF(bDAMP.GT.0.d0) THEN
         VLRe= (CN/Re**NCN)*(C6Sum*DM(NCN)+C7Sum*DM(NCS)/Re
     &   +C8Sum*DM(MCM)/Re**MMN)
c         dVLRedRe= dVLRedRe - NCS*CN*C7Sum*DM(NCS)/Re**(NCS+1)
c     &   +CN*C7Sum*DMP(NCS)/Re**MCM - MCM*CN*C8Sum*DM(MCM)/Re**(MCM+1)
c     &   +CN*C8Sum*DMP(MCM)/Re**MCM
         ELSE
         VLRe= (CN/Re**NCN)*(C6Sum+C7Sum/Re+C8Sum/Re**MMN)
c         dVLRedRe= dVLRedRe -NCS*CN*C7Sum/Re**(NCS+1)
c     &    -MCM*CN*C8Sum/Re**(MCM+1)
       ENDIF
       ENDIF
         phiINF= DLOG(2.d0*De/VLRe)
       ENDIF
       RTPp= YR**NP
       RTPq= YR**NQ
       yp= (RTPp - AREFp)/(RTPp + AREFp)
       yq= (RTPq - AREFq)/(RTPq + AREFq)
       ype= (RTPp - Rep)/(RTPp + Rep)
c caculate the derivative of the parameters of PHI(N) not including
c the coefficient before, the Legendre expansion and exponent expansion.

      NPOW= NS
       IF(YR.GE.Re) NPOW= NL
        yPOW= 1.d0 - yp
        SUM=0.0
        DSUM=0.0
        NPS=0
        DO J=0,NPOW
        PHI(J)=0.0d0
        DO L=0,NPHI(J)
          if (L.GT.6) then
              M6=6
          else
             M6=L
          endif
           DO M=0,M6,2
             IP=IP+1
             PHI(J)=PHI(J)+PV(IP)*ylm(L,M,YTH,YPHI)
             PD(IP)=ylm(L,M,YTH,YPHI)*yq**(J)
            ENDDO
        ENDDO
        SUM=SUM+PHI(J)*yq**(J)
        IF(RREF.LE.0.D0) DSUM=DSUM+yPOW*PHI(J)*(J)*yq**(J-1)
        ENDDO

        PD(IP+1)=1.0D0
        Vasy=PD(IP+1)*PV(IP+1)
        XP= SUM*yPOW+ phiINF*yp

        IF(bDAMP.GT.0.d0) CALL DAMPIG(YR,bDAMP,MMAX,DM,DMP,DMPP)
        IF(bDAMP.GT.0.d0)THEN
          VLR= CN*C6SUM*DM(NCN)/YR**NCN
          ELSE
          VLR= CN*C6Sum/YR**NCN
          ENDIF
        IF(MMN.GT.0) THEN
          IF(bDAMP.GT.0.d0)THEN
             VLR= (CN/YR**NCN)*(C6Sum*DM(NCN)+C7Sum*DM(NCS)/YR
     &       +C8Sum*DM(MCM)/YR**MMN)
             ELSE
             VLR= (CN/YR**NCN)*(C6Sum+C7Sum/YR+C8Sum/YR**MMN)
             ENDIF
       ENDIF
         XPW= DEXP(-XP*ype) * VLR/VLRe
         YC= De*(1.d0 - XPW)**2-De+Vasy 
99      format(1x,3F8.2,F15.5)
         V=YC
c         write(11,98) YTH, YPHI,YR, V
98      format(1x,3F8.2,F15.5)
         RETURN
         END

cccc----------------------------------------------------------------ccccc
        function ylm(L,M,th1,phi)
        implicit real*8 (a-h,o-z)
        dimension p(0:50,0:50)
        common/factorial/ fact(0:40)
        data pifact/12.566370614359d0/

        costh1=dcos(th1)
        call plmrb(p,costh1,L)

c        Normal coeffcient builed in p(L,M)
        if(M.eq.0)then
        ylm=p(L,M)
        else
         if(M.gt.0)then
          ylm=sqrt(2.0)*p(L,M)*dcos(M*phi)
        else
          MM=-M
          ylm=sqrt(2.0)*(-1)**(MM)*p(L,MM)*dsin(-MM*phi)
        endif
        endif
        return
        end
C ----------------------------------------------------------------------------
c
c Compute the set of associated Legendre polynomials P_lm
c for l=0,1,...,lmax, and m=0,1,...,l. First the standard
c polynomials

c   P^m_l(x) = (1/2^l l!)(1-x^2)^(m/2) (d^(l+m)/d x^(l+m))(x^2 -1)^l
c
c are computed, and then multiplied by
c
c  (-1)^m sqrt[(2l+1)(l-m)!/2(l+m)!]/sqrt(2Pi)
c
c to get the P_lm polynomials....
c
        subroutine plmrb(p,x,lmax)
        implicit real*8 (a-h,o-z)
        dimension p(0:50,0:50)
        common/factorial/ fact(0:40)
c inverse of dsqrt(2Pi)
        data twopinv /0.3989422804014d0/
c
c starting value
c
        p(0,0) = 1.d0
        u = dsqrt(1-x*x)
c
c compute the diagonal elements
c
        do l=1,lmax
         p(l,l) = (2*l-1)*p(l-1,l-1)*u
        end do
c
c compute P_lm along the columns with fixed m
c
        do m = 0,lmax-1
        do l = m,lmax-1
         if((l-1).lt.m) then
           pp = 0
         else
           pp = p(l-1,m)
         endif
         p(l+1,m) = ((2*l+1)*x*p(l,m)-(l+m)*pp)/(l-m+1)
        end do
        end do
c
c Renormalize values...
c
        do l=0,lmax
        mm = 1
        do m=0,l
         dnorm = fact(l-m)*(2*l+1)/(2*fact(l+m))
         p(l,m) = mm*twopinv*dsqrt(dnorm)*p(l,m)
         mm = -mm
        end do
        end do
c
        return
        end

C -------------------------------------------------------------------------
c
c compute the matrix of N!
c
        subroutine fct(nmax)
        implicit real*8 (a-h,o-z)
        common/factorial/ f(0:40)
c
        f(0) = 1.d0
        do i=1,nmax
         f(i) = f(i-1)*i
        end do
        return
        end



c***********************************************************************
      SUBROUTINE DAMPIG(r,b,MMAX,DM,DMP,DMPP)
c** Subroutine to generate values DM and the first and second radial
c  derivatives DMP and DMPP of the Tang-Toennies/incomplete gamma 
c  function damping function of all orders up to NMAX at radial distance
c   'r' for damping parameter 'b'
c***********************************************************************
      INTEGER MMAX,m,n
      REAL*8 b,r,br,XP,SSm,SSm1,SSm2,mfact,TK,DM(MMAX),DMP(MMAX),
     1       DMPP(MMAX),SM(-1:MMAX)
     
      br= b*r
      XP= DEXP(-br)
      SSm= 0.d0
      SSm1= 0.d0
      SSm2= 0.d0
      TK= 1.d0
      DO m=1,MMAX
         SSm2= SSm1
         SSm1= SSm
         SSm= SSm + TK
         DM(m)= 1.d0 - XP*SSm
         DMP(m)= b*XP*(SSm - SSm1)
         DMPP(m)= b**2 *XP* (2.d0*SSm1 - SSm - SSm2)
         TK= TK*br/DFLOAT(m)
      ENDDO
      IF(DM(MMAX).LT.1.0D-13) THEN
         mfact= 1.d0
         DO n=1,MMAX
            mfact= mfact*DFLOAT(n)
         ENDDO
         SSm= 0.d0
         TK= (br)**MMAX/mfact
         DO n=MMAX,MMAX+3
            SSm= SSm+TK
            TK= TK*br/DFLOAT(n+1)
         ENDDO
         SM(MMAX)= SSm
         TK= (br)**MMAX/mfact
         DO n=1,MMAX-1
            TK= TK*DFLOAT(MMAX+1-n)/br
            SM(MMAX-n)= TK+SM(MMAX-n+1)
         ENDDO
         SM(0)=1.d0 + SM(1)
         SM(-1)=SM(0)
         DO m=1,MMAX
            DM(m)= XP*SM(m)
            DMP(m)= -b*XP*(SM(m)-SM(m-1))
            DMPP(m)= b**2 *XP*(SM(m)-2.d0*SM(m-1)+SM(m-2))
         ENDDO
      ENDIF
      RETURN
      END
c23456789 123456789 123456789 123456789 123456789 123456789 123456789 12



